// WinAPI.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "WinAPI.h"
#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WINAPI, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_WINAPI);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_WINAPI);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_WINAPI;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

void InsideFrameDemo(HDC hdc)
{
	HPEN hPen;
	HBRUSH hBrush;
	hPen = CreatePen(PS_SOLID | PS_INSIDEFRAME, 20, 0x00FF8080);
	hBrush = CreateSolidBrush(0x0080FFFF);
  SelectObject(hdc, GetStockObject(BLACK_PEN));
  Rectangle(hdc, 15, 15, 115, 115);
  SelectObject(hdc, hPen);
	SelectObject(hdc, hBrush);
  Ellipse(hdc, 15, 15, 115, 115);
  SelectObject(hdc, GetStockObject(BLACK_PEN));
  DeleteObject(hPen);
  SelectObject(hdc, GetStockObject(WHITE_BRUSH));
  Rectangle(hdc, 140, 15, 240, 115);
	hPen = CreatePen(PS_SOLID, 20, 0x00FF8080);
  SelectObject(hdc, hPen);
	SelectObject(hdc, hBrush);
  Ellipse(hdc, 140, 15, 240, 115);
  SelectObject(hdc, GetStockObject(WHITE_PEN));
  DeleteObject(hPen);
  DeleteObject(hBrush);
}

void HatchBrush(HDC hdc)
{
	HBRUSH hBrush, hbOld;
	HPEN hPen, hpOld;
	hBrush = CreateHatchBrush(HS_CROSS, 0x000000A0);
	hPen = CreatePen(PS_SOLID, 8, 0x00D00000);
	hbOld = (HBRUSH)SelectObject(hdc, hBrush);
	hpOld = (HPEN)SelectObject(hdc, hPen);
	Rectangle(hdc, 10,10, 180, 120);
	SelectObject(hdc, hbOld);
	DeleteObject(hBrush);
	hBrush = CreateHatchBrush(HS_DIAGCROSS, 0x0000A000);
	SelectObject(hdc, hBrush);
	RoundRect(hdc, 10,140, 180, 230, 50, 50);
	SelectObject(hdc, hpOld);
	DeleteObject(hPen);
}

void ShowBrush(HDC hdc, int Style, int x, int y, LPCTSTR lpText)
{
	RECT rect;
	rect.left = x;
	rect.top = y;
	rect.right = rect.left + 140;
	rect.bottom = rect.top + 80;
	HBRUSH hb = CreateHatchBrush(Style, 0x00A00000);
	SelectObject(hdc, hb);
	FillRect(hdc, &rect, hb);
	DrawText(hdc, lpText, lstrlen(lpText), &rect,
		DT_SINGLELINE | DT_CENTER | DT_VCENTER);
	DeleteObject(hb);
}

void OnPaint(HDC hdc)
{
	ShowBrush(hdc, HS_BDIAGONAL, 10, 10, "HS_BDIAGONAL");
	ShowBrush(hdc, HS_CROSS, 160, 10, "HS_CROSS");
	ShowBrush(hdc, HS_DIAGCROSS, 310, 10, "HS_DIAGCROSS");
	ShowBrush(hdc, HS_FDIAGONAL, 10, 100, "HS_FDIAGONAL");
	ShowBrush(hdc, HS_HORIZONTAL, 160, 100, "HS_HORIZONTAL");
	ShowBrush(hdc, HS_VERTICAL, 310, 100, "HS_VERTICAL");
//	HatchBrush(hdc);
//	InsideFrameDemo(hdc);
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		OnPaint(hdc);
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}
